// Copyright (c) 2012 Qualcomm Atheros, Inc.  All rights reserved.
// $ATH_LICENSE_HW_HDR_C$
//
// DO NOT EDIT!  This file is automatically generated
//               These definitions are tied to a particular hardware layout


#ifndef _VHT_SIG_B_MAC_MU80_H_
#define _VHT_SIG_B_MAC_MU80_H_
#if !defined(__ASSEMBLER__)
#endif

// ################ START SUMMARY #################
//
//	Dword	Fields
//	0	length[18:0], mcs[22:19], tail[28:23], mu_user_number[31:29]
//
// ################ END SUMMARY #################

#define NUM_OF_DWORDS_VHT_SIG_B_MAC_MU80 1

struct vht_sig_b_mac_mu80 {
    volatile uint32_t length                          : 19, //[18:0]
                      mcs                             :  4, //[22:19]
                      tail                            :  6, //[28:23]
                      mu_user_number                  :  3; //[31:29]
};

/*

length
			
			VHT-SIG-B Length (in units of 4 octets) = ceiling
			(LENGTH/4)
			
			<legal all>

mcs
			
			Modulation as described in vht_sig_a mcs field <legal
			0-9>

tail
			
			Used to terminate the trellis of the convolutional
			decoder.  Set to 0.  <legal 0>

mu_user_number
			
			Not part of VHT-SIG-B.
			
			Mapping from user number to mu_user_number  <legal 0-3>
*/


/* Description		VHT_SIG_B_MAC_MU80_0_LENGTH
			
			VHT-SIG-B Length (in units of 4 octets) = ceiling
			(LENGTH/4)
			
			<legal all>
*/
#define VHT_SIG_B_MAC_MU80_0_LENGTH_OFFSET                           0x00000000
#define VHT_SIG_B_MAC_MU80_0_LENGTH_LSB                              0
#define VHT_SIG_B_MAC_MU80_0_LENGTH_MASK                             0x0007ffff

/* Description		VHT_SIG_B_MAC_MU80_0_MCS
			
			Modulation as described in vht_sig_a mcs field <legal
			0-9>
*/
#define VHT_SIG_B_MAC_MU80_0_MCS_OFFSET                              0x00000000
#define VHT_SIG_B_MAC_MU80_0_MCS_LSB                                 19
#define VHT_SIG_B_MAC_MU80_0_MCS_MASK                                0x00780000

/* Description		VHT_SIG_B_MAC_MU80_0_TAIL
			
			Used to terminate the trellis of the convolutional
			decoder.  Set to 0.  <legal 0>
*/
#define VHT_SIG_B_MAC_MU80_0_TAIL_OFFSET                             0x00000000
#define VHT_SIG_B_MAC_MU80_0_TAIL_LSB                                23
#define VHT_SIG_B_MAC_MU80_0_TAIL_MASK                               0x1f800000

/* Description		VHT_SIG_B_MAC_MU80_0_MU_USER_NUMBER
			
			Not part of VHT-SIG-B.
			
			Mapping from user number to mu_user_number  <legal 0-3>
*/
#define VHT_SIG_B_MAC_MU80_0_MU_USER_NUMBER_OFFSET                   0x00000000
#define VHT_SIG_B_MAC_MU80_0_MU_USER_NUMBER_LSB                      29
#define VHT_SIG_B_MAC_MU80_0_MU_USER_NUMBER_MASK                     0xe0000000


#endif // _VHT_SIG_B_MAC_MU80_H_
