// Copyright (c) 2012 Qualcomm Atheros, Inc.  All rights reserved.
// $ATH_LICENSE_HW_HDR_C$
//
// DO NOT EDIT!  This file is automatically generated
//               These definitions are tied to a particular hardware layout


#ifndef _VHT_SIG_B_MAC_SU80_H_
#define _VHT_SIG_B_MAC_SU80_H_
#if !defined(__ASSEMBLER__)
#endif

// ################ START SUMMARY #################
//
//	Dword	Fields
//	0	length[20:0], vhtb_reserved[22:21], tail[28:23], reserved[31:29]
//
// ################ END SUMMARY #################

#define NUM_OF_DWORDS_VHT_SIG_B_MAC_SU80 1

struct vht_sig_b_mac_su80 {
    volatile uint32_t length                          : 21, //[20:0]
                      vhtb_reserved                   :  2, //[22:21]
                      tail                            :  6, //[28:23]
                      reserved                        :  3; //[31:29]
};

/*

length
			
			VHT-SIG-B Length (in units of 4 octets) = ceiling
			(LENGTH/4)
			
			<legal all>

vhtb_reserved
			
			Reserved:  Set  to all ones and ignored on receive 
			<legal 3>

tail
			
			Used to terminate the trellis of the convolutional
			decoder.
			
			Set to 0.  <legal 0>

reserved
			
			Not part of VHT-SIG-B.
			
			Reserved: Set to 0 and ignored on receive  <legal 0>
*/


/* Description		VHT_SIG_B_MAC_SU80_0_LENGTH
			
			VHT-SIG-B Length (in units of 4 octets) = ceiling
			(LENGTH/4)
			
			<legal all>
*/
#define VHT_SIG_B_MAC_SU80_0_LENGTH_OFFSET                           0x00000000
#define VHT_SIG_B_MAC_SU80_0_LENGTH_LSB                              0
#define VHT_SIG_B_MAC_SU80_0_LENGTH_MASK                             0x001fffff

/* Description		VHT_SIG_B_MAC_SU80_0_VHTB_RESERVED
			
			Reserved:  Set  to all ones and ignored on receive 
			<legal 3>
*/
#define VHT_SIG_B_MAC_SU80_0_VHTB_RESERVED_OFFSET                    0x00000000
#define VHT_SIG_B_MAC_SU80_0_VHTB_RESERVED_LSB                       21
#define VHT_SIG_B_MAC_SU80_0_VHTB_RESERVED_MASK                      0x00600000

/* Description		VHT_SIG_B_MAC_SU80_0_TAIL
			
			Used to terminate the trellis of the convolutional
			decoder.
			
			Set to 0.  <legal 0>
*/
#define VHT_SIG_B_MAC_SU80_0_TAIL_OFFSET                             0x00000000
#define VHT_SIG_B_MAC_SU80_0_TAIL_LSB                                23
#define VHT_SIG_B_MAC_SU80_0_TAIL_MASK                               0x1f800000

/* Description		VHT_SIG_B_MAC_SU80_0_RESERVED
			
			Not part of VHT-SIG-B.
			
			Reserved: Set to 0 and ignored on receive  <legal 0>
*/
#define VHT_SIG_B_MAC_SU80_0_RESERVED_OFFSET                         0x00000000
#define VHT_SIG_B_MAC_SU80_0_RESERVED_LSB                            29
#define VHT_SIG_B_MAC_SU80_0_RESERVED_MASK                           0xe0000000


#endif // _VHT_SIG_B_MAC_SU80_H_
