// Copyright (c) 2012 Qualcomm Atheros, Inc.  All rights reserved.
// $ATH_LICENSE_HW_HDR_C$
//
// DO NOT EDIT!  This file is automatically generated
//               These definitions are tied to a particular hardware layout


#ifndef _L_SIG_B_H_
#define _L_SIG_B_H_
#if !defined(__ASSEMBLER__)
#endif

// ################ START SUMMARY #################
//
//	Dword	Fields
//	0	rate[3:0], length[15:4], reserved[31:16]
//
// ################ END SUMMARY #################

#define NUM_OF_DWORDS_L_SIG_B 1

struct l_sig_b {
    volatile uint32_t rate                            :  4, //[3:0]
                      length                          : 12, //[15:4]
                      reserved                        : 16; //[31:16]
};

/*

rate
			
			This format is originally defined for OFDM as a 4 bit
			field but the 5th bit was added to indicate 11b formatted
			frames.  In the standard bit [4] is specified as reserved. 
			For 11b frames this L-SIG is transformed in the PHY into the
			11b preamble format.  The following are the rates:
			
			<enum 1    dsss_1_mpbs_long> DSSS 1 Mbps long
			
			<enum 2    dsss_2_mbps_long> DSSS 2 Mbps long
			
			<enum 3    cck_5_5_mbps_long> CCK 5.5 Mbps long
			
			<enum 4    cck_11_mbps_long> CCK 11 Mbps long
			
			<enum 5    dsss_2_mbps_short> DSSS 2 Mbps short
			
			<enum 6    cck_5_5_mbps_short> CCK 5.5 Mbps short
			
			<enum 7    cck_11_mbps_short> CCK 11 Mbps short
			
			<legal 1-7>

length
			
			The length indicates the number of octets in this MPDU.
			
			<legal all>

reserved
			
			Reserved: Should be set to 0 by the transmitting MAC and
			ignored by the PHY <legal 0>
*/


/* Description		L_SIG_B_0_RATE
			
			This format is originally defined for OFDM as a 4 bit
			field but the 5th bit was added to indicate 11b formatted
			frames.  In the standard bit [4] is specified as reserved. 
			For 11b frames this L-SIG is transformed in the PHY into the
			11b preamble format.  The following are the rates:
			
			<enum 1    dsss_1_mpbs_long> DSSS 1 Mbps long
			
			<enum 2    dsss_2_mbps_long> DSSS 2 Mbps long
			
			<enum 3    cck_5_5_mbps_long> CCK 5.5 Mbps long
			
			<enum 4    cck_11_mbps_long> CCK 11 Mbps long
			
			<enum 5    dsss_2_mbps_short> DSSS 2 Mbps short
			
			<enum 6    cck_5_5_mbps_short> CCK 5.5 Mbps short
			
			<enum 7    cck_11_mbps_short> CCK 11 Mbps short
			
			<legal 1-7>
*/
#define L_SIG_B_0_RATE_OFFSET                                        0x00000000
#define L_SIG_B_0_RATE_LSB                                           0
#define L_SIG_B_0_RATE_MASK                                          0x0000000f

/* Description		L_SIG_B_0_LENGTH
			
			The length indicates the number of octets in this MPDU.
			
			<legal all>
*/
#define L_SIG_B_0_LENGTH_OFFSET                                      0x00000000
#define L_SIG_B_0_LENGTH_LSB                                         4
#define L_SIG_B_0_LENGTH_MASK                                        0x0000fff0

/* Description		L_SIG_B_0_RESERVED
			
			Reserved: Should be set to 0 by the transmitting MAC and
			ignored by the PHY <legal 0>
*/
#define L_SIG_B_0_RESERVED_OFFSET                                    0x00000000
#define L_SIG_B_0_RESERVED_LSB                                       16
#define L_SIG_B_0_RESERVED_MASK                                      0xffff0000


#endif // _L_SIG_B_H_
