// Copyright (c) 2012 Qualcomm Atheros, Inc.  All rights reserved.
// $ATH_LICENSE_HW_HDR_C$
//
// DO NOT EDIT!  This file is automatically generated
//               These definitions are tied to a particular hardware layout


#ifndef _RX_LOCATION_INFO_H_
#define _RX_LOCATION_INFO_H_
#if !defined(__ASSEMBLER__)
#endif

// ################ START SUMMARY #################
//
//	Dword	Fields
//	0	rtt_corr_value[16:0], reserved[29:17], chan_est_valid[30], rtt_valid[31]
//
// ################ END SUMMARY #################

#define NUM_OF_DWORDS_RX_LOCATION_INFO 1

struct rx_location_info {
    volatile uint32_t rtt_corr_value                  : 17, //[16:0]
                      reserved                        : 13, //[29:17]
                      chan_est_valid                  :  1, //[30]
                      rtt_valid                       :  1; //[31]
};

/*

rtt_corr_value
			
			RTT correction value
			
			<legal all>

reserved
			
			Reserved - set to 0 by PHY  <legal 0>

chan_est_valid
			
			If this bit is set, the RTT module retains a valid
			channel estimate that is available for software to download
			via APB registers  <legal 0-1>

rtt_valid
			
*/


/* Description		RX_LOCATION_INFO_0_RTT_CORR_VALUE
			
			RTT correction value
			
			<legal all>
*/
#define RX_LOCATION_INFO_0_RTT_CORR_VALUE_OFFSET                     0x00000000
#define RX_LOCATION_INFO_0_RTT_CORR_VALUE_LSB                        0
#define RX_LOCATION_INFO_0_RTT_CORR_VALUE_MASK                       0x0001ffff

/* Description		RX_LOCATION_INFO_0_RESERVED
			
			Reserved - set to 0 by PHY  <legal 0>
*/
#define RX_LOCATION_INFO_0_RESERVED_OFFSET                           0x00000000
#define RX_LOCATION_INFO_0_RESERVED_LSB                              17
#define RX_LOCATION_INFO_0_RESERVED_MASK                             0x3ffe0000

/* Description		RX_LOCATION_INFO_0_CHAN_EST_VALID
			
			If this bit is set, the RTT module retains a valid
			channel estimate that is available for software to download
			via APB registers  <legal 0-1>
*/
#define RX_LOCATION_INFO_0_CHAN_EST_VALID_OFFSET                     0x00000000
#define RX_LOCATION_INFO_0_CHAN_EST_VALID_LSB                        30
#define RX_LOCATION_INFO_0_CHAN_EST_VALID_MASK                       0x40000000

/* Description		RX_LOCATION_INFO_0_RTT_VALID
			
*/
#define RX_LOCATION_INFO_0_RTT_VALID_OFFSET                          0x00000000
#define RX_LOCATION_INFO_0_RTT_VALID_LSB                             31
#define RX_LOCATION_INFO_0_RTT_VALID_MASK                            0x80000000


#endif // _RX_LOCATION_INFO_H_
