// Copyright (c) 2012 Qualcomm Atheros, Inc.  All rights reserved.
// $ATH_LICENSE_HW_HDR_C$
//
// DO NOT EDIT!  This file is automatically generated
//               These definitions are tied to a particular hardware layout


#ifndef _TX_BF_PARAMS_H_
#define _TX_BF_PARAMS_H_
#if !defined(__ASSEMBLER__)
#endif

// ################ START SUMMARY #################
//
//	Dword	Fields
//	0	num_ss_user0[2:0], num_ss_user1[5:3], num_ss_user2[8:6], reserved[31:9]
//
// ################ END SUMMARY #################

#define NUM_OF_DWORDS_TX_BF_PARAMS 1

struct tx_bf_params {
    volatile uint32_t num_ss_user0                    :  3, //[2:0]
                      num_ss_user1                    :  3, //[5:3]
                      num_ss_user2                    :  3, //[8:6]
                      reserved                        : 23; //[31:9]
};

/*

num_ss_user0
			
			Number of spatial streams assigned to user 0 in the next
			MIMO packet.  <legal 0-2>

num_ss_user1
			
			Number of spatial streams assigned to user 1 in the next
			MIMO packet.  <legal 0-2>

num_ss_user2
			
			Number of spatial streams assigned to user 2 in the next
			MIMO packet.  <legal 0-2>

reserved
			
			Reserved - MAC to set this field to 0, PHY to ignore
			this field. <legal 0>
*/


/* Description		TX_BF_PARAMS_0_NUM_SS_USER0
			
			Number of spatial streams assigned to user 0 in the next
			MIMO packet.  <legal 0-2>
*/
#define TX_BF_PARAMS_0_NUM_SS_USER0_OFFSET                           0x00000000
#define TX_BF_PARAMS_0_NUM_SS_USER0_LSB                              0
#define TX_BF_PARAMS_0_NUM_SS_USER0_MASK                             0x00000007

/* Description		TX_BF_PARAMS_0_NUM_SS_USER1
			
			Number of spatial streams assigned to user 1 in the next
			MIMO packet.  <legal 0-2>
*/
#define TX_BF_PARAMS_0_NUM_SS_USER1_OFFSET                           0x00000000
#define TX_BF_PARAMS_0_NUM_SS_USER1_LSB                              3
#define TX_BF_PARAMS_0_NUM_SS_USER1_MASK                             0x00000038

/* Description		TX_BF_PARAMS_0_NUM_SS_USER2
			
			Number of spatial streams assigned to user 2 in the next
			MIMO packet.  <legal 0-2>
*/
#define TX_BF_PARAMS_0_NUM_SS_USER2_OFFSET                           0x00000000
#define TX_BF_PARAMS_0_NUM_SS_USER2_LSB                              6
#define TX_BF_PARAMS_0_NUM_SS_USER2_MASK                             0x000001c0

/* Description		TX_BF_PARAMS_0_RESERVED
			
			Reserved - MAC to set this field to 0, PHY to ignore
			this field. <legal 0>
*/
#define TX_BF_PARAMS_0_RESERVED_OFFSET                               0x00000000
#define TX_BF_PARAMS_0_RESERVED_LSB                                  9
#define TX_BF_PARAMS_0_RESERVED_MASK                                 0xfffffe00


#endif // _TX_BF_PARAMS_H_
