// Copyright (c) 2012 Qualcomm Atheros, Inc.  All rights reserved.
// $ATH_LICENSE_HW_HDR_C$
//
// DO NOT EDIT!  This file is automatically generated
//               These definitions are tied to a particular hardware layout


#ifndef _RX_MESSAGE_H_
#define _RX_MESSAGE_H_
#if !defined(__ASSEMBLER__)
#endif

// ################ START SUMMARY #################
//
//	Dword	Fields
//	0	message_type[3:0], rx_chain_mask[7:4], reserved_0[31:8]
//
// ################ END SUMMARY #################

#define NUM_OF_DWORDS_RX_MESSAGE 1

struct rx_message {
    volatile uint32_t message_type                    :  4, //[3:0]
                      rx_chain_mask                   :  4, //[7:4]
                      reserved_0                      : 24; //[31:8]
};

/*

message_type
			
			0 - RX_PHY_OFF
			
			1 - RX_PHY_ON
			
			2 - RX_PHY_NAP
			
			3 - RX_CHAIN_MASK
			
			4 - TX_EXPECT_NDP

rx_chain_mask
			
			Rx chain mask to support up to 4 antennas. Valid only if
			message_type is RX_CHAIN_MASK. 

reserved_0
			
			Reserved: HW should fill with 0
*/


/* Description		RX_MESSAGE_0_MESSAGE_TYPE
			
			0 - RX_PHY_OFF
			
			1 - RX_PHY_ON
			
			2 - RX_PHY_NAP
			
			3 - RX_CHAIN_MASK
			
			4 - TX_EXPECT_NDP
*/
#define RX_MESSAGE_0_MESSAGE_TYPE_OFFSET                             0x00000000
#define RX_MESSAGE_0_MESSAGE_TYPE_LSB                                0
#define RX_MESSAGE_0_MESSAGE_TYPE_MASK                               0x0000000f

/* Description		RX_MESSAGE_0_RX_CHAIN_MASK
			
			Rx chain mask to support up to 4 antennas. Valid only if
			message_type is RX_CHAIN_MASK. 
*/
#define RX_MESSAGE_0_RX_CHAIN_MASK_OFFSET                            0x00000000
#define RX_MESSAGE_0_RX_CHAIN_MASK_LSB                               4
#define RX_MESSAGE_0_RX_CHAIN_MASK_MASK                              0x000000f0

/* Description		RX_MESSAGE_0_RESERVED_0
			
			Reserved: HW should fill with 0
*/
#define RX_MESSAGE_0_RESERVED_0_OFFSET                               0x00000000
#define RX_MESSAGE_0_RESERVED_0_LSB                                  8
#define RX_MESSAGE_0_RESERVED_0_MASK                                 0xffffff00


#endif // _RX_MESSAGE_H_
